<?php
namespace wcf\system\event\listener;
use wcf\system\event\IEventListener;
use wcf\system\exception\AJAXException;
use wcf\system\request\LinkHandler;
use wcf\system\request\RequestHandler;
use wcf\system\WCF;
use wcf\util\HeaderUtil;

/**
 * Listener for the forced display of the terms of use form.
 *
 * @author	Sascha Greuel <sascha@softcreatr.de>
 * @copyright	2013 Sascha Greuel
 * @license	Creative Commons Attribution-NoDerivatives <http://creativecommons.org/licenses/by-nd/4.0/legalcode>
 * @package	be.bastelstu.sascha.termsofuse
 * @subpackage	system.event.listener
 * @category	Community Framework
 */
class TermsOfUseUserListener implements IEventListener {
	/**
	 * @see	\wcf\system\event\IEventListener::execute()
	 */
	public function execute($eventObj, $className, $eventName) {
		if (MODULE_USER_TERMS_OF_USE && WCF::getUser()->userID && !WCF::getSession()->getPermission('admin.general.canIgnoreTermsOfUse') && !WCF::getUser()->disclaimerAccepted) {
			if (get_class($eventObj) !== 'wcf\form\TermsForm' && !RequestHandler::getInstance()->getActiveRequest()->isAvailableDuringOfflineMode()) {
				if (isset($_SERVER['HTTP_X_REQUESTED_WITH']) && ($_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest')) {
					throw new AJAXException(WCF::getLanguage()->get('wcf.ajax.error.permissionDenied'), AJAXException::INSUFFICIENT_PERMISSIONS);
				}
				else {
					HeaderUtil::redirect(LinkHandler::getInstance()->getLink('Terms'));
				}
				
				exit;
			}
		}
	}
}
